(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: TXTSAV.PAS                                                     *)
(*  Obsah: program na ulozeni obrazovek vyfocenych programem TXTCAP.EXE    *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 25.7.2020                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: C:\TXTCAP.$$$ (vytvoril TXTCAP)                          *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program UkladacTextovychScreenshotu;
{$I-}

const KapacitaPameti=30;

type ObrazovkaBezBarev=array[1..25,1..80] of char;

var UlozeneObrazovky:array[1..kapacitapameti] of obrazovkabezbarev;
    PocetUlozenychObrazovek:word;

function NactiObrazovky:boolean; {zkopiruje vyfocene obrazovky z pameti rezidentniho programu do zdejsi promenne}
var f:file of pointer;
    p:pointer;
Begin
nactiobrazovky:=false;
pocetulozenychobrazovek:=0;
assign(f,'C:\TXTCAP.$$$');
reset(f);
read(f,p);
pocetulozenychobrazovek:=word(p^);
read(f,p);
close(f);
if (ioresult<>0) or (pocetulozenychobrazovek>30) then exit;
move(p^,ulozeneobrazovky,pocetulozenychobrazovek*sizeof(obrazovkabezbarev));
nactiobrazovky:=true;
End;{nactiobrazovky}

function na2(cislo:word):string; {zarovna cislo na dvojciferne s nulou na zacatku}
var v:string;
Begin
str(cislo,v);
if length(v)<2 then na2:='0'+v else na2:=v;
End;

function UlozObrazovky:boolean; {ulozi vsechny nafocene obrazovky do souboru}
var soubor:text;
    o,i,j:word;
    znak:char;
    obrazovka:obrazovkabezbarev;
    jmeno:string[12];
    radek:string[80];
Begin
for o:=1 to pocetulozenychobrazovek do
  begin
  jmeno:='OBR'+na2(o)+'.TXT';
  writeln(jmeno);
  assign(soubor,jmeno);
  rewrite(soubor);
  for i:=1 to 25 do
    begin
    radek:='';
    for j:=1 to 80 do begin {dalo by se mohutne optimalizovat, ale kaslu na to, rychlost tady neni dulezita}
                      znak:=ulozeneobrazovky[o,i,j];
                      radek:=radek+znak;
                      end;
    writeln(soubor,radek);
    end;
  close(soubor);
  end;
ulozobrazovky:=ioresult=0;
End;{ulozobrazovky}

BEGIN
if nactiobrazovky
  then begin
       if ulozobrazovky
         then writeln('Uspesne ulozeno.')
         else writeln('Chyba pri zapisu do souboru.');
       writeln('Nechcete-li pokracovat v ukladani, muzete smazat soubor C:\TXTCAP.$$$.');
       end
  else writeln('Nepovedlo se nacist soubor C:\TXTCAP.$$$.');
END.